#include <stdio.h>
#include <math.h>
// *.fit
char head[72][80];
double a8[8],b8[8];
#define bok 48.
// common
double cx,cy,pi;
FILE *fp,*fp3;
int n1,n2,ccd;
main(int ac,char **av)
{
  int i,j,k;
  char   a[183],b[80],f1[20],f2[20];  
  double ra,de,x,y;
  float gain,rdno,x1,x2,x3,x4;
  pi=4.*atan(1.0); cx=pi/12.; cy=pi/180.;
  if(ac<2){ printf("\n\t*** uslap ******\n");
            printf("\n\t                   jiang 2011,5,5\n");
            printf("\n\tUsage: uslap p*.fit\n");
            printf("\n\t--> p*.coo p*.usl p*.ap\n\n");
            exit(0);
  }
  strcpy(f1,av[1]); k=strlen(f1); f1[k-3]='c'; f1[k-2]=f1[k-1]='o';
  strcpy(f2,av[1]);          f2[k-3]='u'; f2[k-2]='s'; f2[k-1]='l';
  fp=fopen(av[1],"rb");
  if(fp==0){ printf("\n\t%s input file not found!\n",av[1]); exit(0); }
  fread(head,70,80,fp); fclose(fp);
  k=indexpos(head,"NAXIS1  ",72);
  sscanf(&head[k++][23],"%d",&n1);
  sscanf(&head[k++][23],"%d",&n2);
  if(n1!=4096 || n2!=4032){ printf("\nnot BOK_ccd !\n\n"); exit(0); }
  k=indexpos(head,"A81     ",72);
  if(k==72){ printf("\nfits_file not coordinated !\n"); exit(0); }
  for(i=0;i<8;i++)sscanf(&head[k+i][10],"%le",&a8[i]);
  xytoad(a8,b8);
  k=indexpos(head,"DEC-OBS ",72);
  if(k==72){ printf("%s not full coordiantion\n",av[1]); exit(0); }
  head[k][79]=0;
//  sprintf(b,"usl %s 31 %s 27. !",&head[k][52],f2);
  sprintf(b,"usl %s 31 %s 27.",&head[k][52],f2);
  system(b);
  fp3=fopen(f1,"w");
  k=indexpos(head,"RDNOCAL ",72);
  sscanf(&head[k][9],"%f %f %f %f",&x1,&x2,&x3,&x4);
  rdno=(x1+x2+x3+x4)/4;
  k=indexpos(head,"GAINCAL ",72);
  sscanf(&head[k][9],"%f %f %f %f",&x1,&x2,&x3,&x4);
  gain=(x1+x2+x3+x4)/4;
  fprintf(fp3," NL   NX   NY  LOWBAD HIGHBAD  THRESH");
  fprintf(fp3,"     AP1  PH/ADU  RNOISE    FRAD\n");
  fprintf(fp3,"  1 4096 4032    0.1  60000.0   22.76   10.00");
  fprintf(fp3,"%8.2f%8.2f    10.00\n\n",gain,rdno);
  k=indexpos(head,"CCD_NO: ",72);
  sscanf(&head[k][23],"%d",&ccd);

  fp=fopen(f2,"r");
l10: 
  fgets(a,183,fp);  if(feof(fp))goto l20;
  if(a[0]=='#')goto l10;
  a[5]=a[18]=a[31]=0;
  chs(&a[6],&ra);
  chs(&a[19],&de);
  rad_xy(a8[6],a8[7],ra,de,&x,&y);
  if(x<10. || x>n1-10.)goto l10;
  if(y<10. || y>n2-10.)goto l10;
  if(ccd==4)if(x<n1/2-10. || y>n2/2-10.)goto l10;
  fprintf(fp3,"%s %9.3lf %9.3lf\n",a,x,y);
  goto l10;
l20:
  fclose(fp); fclose(fp3);
  sprintf(b,"u_phot4k %s",av[1]);
  system(b);
}

chs(a,y)
char *a; double *y;
{
  double x;
  char b[128];
  int i,j,k;
  strcpy(b,a); k=strlen(b);
  j=1; for(i=0;i<k;i++){ if(b[i]==32)continue; if(b[i]=='-')j=-1; break; }
  for(i=0;i<k;i++)if(b[i]<'.' || b[i]> '9')b[i]=32;
  i=k=0; x=0.; sscanf(b,"%d %d %lf",&i,&k,&x);
  x=k/60.+x/3600.+i;
  *y=x*j;
}

xytoad(x,a)
double *x,*a;
{
  double z;
  z=x[0]*x[3]-x[2]*x[1];
  a[0]= x[3]/z;
  a[1]=-x[1]/z;
  a[2]=-x[2]/z;
  a[3]= x[0]/z;
  a[4]= (x[2]*x[5]-x[4]*x[3])/z;
  a[5]= (x[4]*x[1]-x[0]*x[5])/z;
}

rad_xy(ac,dc,ra,de,x,y)
double ac,dc,ra,de,*x,*y;
{
  double xi,xn, tmp,rar,der;
  rar=ra*cx; der=de*cy;
  tmp=atan(tan(der)/cos(rar-ac));
  xi=cos(tmp)*tan(rar-ac)/cos(tmp-dc);
  xn=tan(tmp-dc);
  tmp=1.+bok*(xi*xi+xn*xn);
  xi*=tmp; xn*=tmp;
  *x=b8[0]*xi+b8[2]*xn+b8[4];
  *y=b8[1]*xi+b8[3]*xn+b8[5];
}

xy_rad(ac,dc,x,y,ra,de)
double ac,dc,x,y,*ra,*de;
{
  double xi,xn,tmp,tmp1;
  double x1,y1,r1,d1;
  int i;
  xi=a8[0]*x+a8[2]*y+a8[4];
  xn=a8[1]*x+a8[3]*y+a8[5];
  tmp=1.+bok*(xi*xi+xn*xn);
  for(i=0;i<4;i++){
    x1=xi/tmp; y1=xn/tmp;
    tmp=tan(dc);  tmp1=1.-y1*tmp;
    r1=atan(x1/cos(dc)/tmp1);
    d1=atan((y1+tmp)*cos(r1)/tmp1);
    r1+=ac;
    tmp=atan(tan(d1)/cos(r1-ac));
    x1=cos(tmp)*tan(r1-ac)/cos(tmp-dc);
    y1=tan(tmp-dc);
    tmp=1.+bok*(x1*x1+y1*y1);
  }
  xi/=tmp; xn/=tmp;
  tmp=tan(dc);  tmp1=1.-xn*tmp;
  *ra=atan(xi/cos(dc)/tmp1);
  *de=atan((xn+tmp)*cos(*ra)/tmp1);
  *ra+=ac;
  tmp=(*de)-dc; if(tmp<0.)tmp=-tmp;
  if(tmp>2.){  *de=-(*de);  *ra+=pi; }
  if(*ra<0.)*ra+=(pi+pi);
  *ra/=cx; *de/=cy;
}
